package org.eclipse.jdt.internal.compiler.apt.dispatch;

package .tmp;

import javax.annotation.processing.Messager;
import javax.lang.model.element.AnnotationMirror;
import javax.lang.model.element.AnnotationValue;
import javax.lang.model.element.Element;
import javax.tools.Diagnostic;
import org.eclipse.jdt.core.compiler.CategorizedProblem;
import org.eclipse.jdt.internal.compiler.apt.dispatch.AptProblem;
import org.eclipse.jdt.internal.compiler.apt.dispatch.BaseMessagerImpl;
import org.eclipse.jdt.internal.compiler.apt.dispatch.BaseProcessingEnvImpl;
import org.eclipse.jdt.internal.compiler.batch.Main;

public class BatchMessagerImpl extends BaseMessagerImpl implements Messager {
  private final Main _compiler;
  
  private final BaseProcessingEnvImpl _processingEnv;
  
  public BatchMessagerImpl(BaseProcessingEnvImpl processingEnv, Main compiler) {
    this._compiler = compiler;
    this._processingEnv = processingEnv;
  }
  
  public void printMessage(Diagnostic.Kind kind, CharSequence msg) {
    printMessage(kind, msg, null, null, null);
  }
  
  public void printMessage(Diagnostic.Kind kind, CharSequence msg, Element e) {
    printMessage(kind, msg, e, null, null);
  }
  
  public void printMessage(Diagnostic.Kind kind, CharSequence msg, Element e, AnnotationMirror a) {
    printMessage(kind, msg, e, a, null);
  }
  
  public void printMessage(Diagnostic.Kind kind, CharSequence msg, Element e, AnnotationMirror a, AnnotationValue v) {
    if (kind == Diagnostic.Kind.ERROR)
      this._processingEnv.setErrorRaised(true); 
    AptProblem aptProblem = createProblem(kind, msg, e, a, v);
    if (aptProblem != null)
      this._compiler.addExtraProblems((CategorizedProblem)aptProblem); 
  }
}
